"""sellout_reports_and_exports

Revision ID: dd157d80811d
Revises: 9c7b19a00d87
Create Date: 2021-11-16 14:05:31.698614

"""
from alembic import op
import sqlalchemy as sa
import adf.services.database.custom_types


# revision identifiers, used by Alembic.
revision = 'dd157d80811d'
down_revision = '9c7b19a00d87'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('sellout_ibp_reports',
    sa.Column('id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('created_at', sa.DateTime(timezone=True), server_default=sa.text('CURRENT_TIMESTAMP'), nullable=True),
    sa.Column('updated_at', sa.DateTime(timezone=True), nullable=True),
    sa.Column('business_unit_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.Column('pipeline_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.Column('status', sa.String(), nullable=False),
    sa.Column('reason', sa.String(), nullable=True),
    sa.Column('description', adf.services.database.custom_types.CustomJSON(), nullable=False),
    sa.ForeignKeyConstraint(['business_unit_id'], ['business_units.id'], ),
    sa.ForeignKeyConstraint(['pipeline_id'], ['pipeline_reports.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('sellout_ibp_exports',
    sa.Column('export_to_ibp', sa.Boolean(), nullable=True),
    sa.Column('sales_organization', sa.String(), nullable=False),
    sa.Column('execution_date', sa.DateTime(timezone=True), nullable=False),
    sa.Column('product_code', sa.String(), nullable=False),
    sa.Column('product_level', sa.String(), nullable=False),
    sa.Column('location_code', sa.String(), nullable=False),
    sa.Column('location_level', sa.String(), nullable=True),
    sa.Column('customer_code', sa.String(), nullable=False),
    sa.Column('customer_level', sa.String(), nullable=True),
    sa.Column('date', sa.DateTime(timezone=True), nullable=False),
    sa.Column('sellout_volumes', sa.Float(), nullable=True),
    sa.Column('sellout_ibp_report_id', adf.services.database.custom_types.GUID(), nullable=False),
    sa.Column('pipeline_id', adf.services.database.custom_types.GUID(), nullable=True),
    sa.ForeignKeyConstraint(['pipeline_id'], ['pipeline_reports.id'], ),
    sa.ForeignKeyConstraint(['sellout_ibp_report_id'], ['sellout_ibp_reports.id'], ),
    sa.PrimaryKeyConstraint('sales_organization', 'sellout_ibp_report_id', 'product_code', 'location_code', 'customer_code', 'date'),
    sa.UniqueConstraint('sales_organization', 'sellout_ibp_report_id', 'product_code', 'location_code', 'customer_code', 'date')
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('sellout_ibp_exports')
    op.drop_table('sellout_ibp_reports')
    # ### end Alembic commands ###
